"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const Button_1 = __importDefault(require("../Button"));
const Icons_1 = __importDefault(require("../Icons"));
const style_1 = __importDefault(require("./style"));
const CitySelect_1 = __importDefault(require("../CitySelect"));
const City = ({ types = 'city', label, placeholder = '请选择', styleContainer = {}, stylesText = {}, stylesLabel = {}, currentData = '', onSubmit, }) => {
    const onCity = () => {
        (0, CitySelect_1.default)({
            types,
            title: '选择城市',
            currentData,
            onSumbit: (res) => {
                onSubmit === null || onSubmit === void 0 ? void 0 : onSubmit(res);
            }
        });
    };
    const renderArea = () => {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j;
        let text = placeholder;
        switch (types) {
            case 'prov':
                if ((_a = currentData === null || currentData === void 0 ? void 0 : currentData.prov) === null || _a === void 0 ? void 0 : _a.id) {
                    text = ((_b = currentData === null || currentData === void 0 ? void 0 : currentData.prov) === null || _b === void 0 ? void 0 : _b.name) || '';
                }
                break;
            case 'city':
                if ((_c = currentData === null || currentData === void 0 ? void 0 : currentData.city) === null || _c === void 0 ? void 0 : _c.id) {
                    text = (((_d = currentData === null || currentData === void 0 ? void 0 : currentData.prov) === null || _d === void 0 ? void 0 : _d.name) + ' ' || '') + (((_e = currentData === null || currentData === void 0 ? void 0 : currentData.city) === null || _e === void 0 ? void 0 : _e.name) + ' ' || '');
                }
                break;
            default:
                text = (((_f = currentData === null || currentData === void 0 ? void 0 : currentData.prov) === null || _f === void 0 ? void 0 : _f.name) + ' ' || '') + (((_g = currentData === null || currentData === void 0 ? void 0 : currentData.city) === null || _g === void 0 ? void 0 : _g.name) + ' ' || '') + (((_h = currentData === null || currentData === void 0 ? void 0 : currentData.area) === null || _h === void 0 ? void 0 : _h.name) || '');
                break;
        }
        return (react_1.default.createElement(Button_1.default, { styleContainer: style_1.default.picker, onPress: onCity },
            react_1.default.createElement(react_native_1.Text, { style: [
                    style_1.default.pickerText,
                    Object.assign({}, stylesText),
                    ((_j = currentData === null || currentData === void 0 ? void 0 : currentData.prov) === null || _j === void 0 ? void 0 : _j.id) ? { color: '#333' } : {},
                ], numberOfLines: 1 }, text),
            react_1.default.createElement(Icons_1.default, { type: 'SimpleLineIcons', name: 'arrow-right', color: '#ccc' })));
    };
    return (react_1.default.createElement(react_native_1.View, { style: [
            style_1.default.container,
            Object.assign({}, styleContainer)
        ] },
        label && react_1.default.createElement(react_native_1.Text, { style: [style_1.default.label, Object.assign({}, stylesLabel)] }, label),
        renderArea()));
};
exports.default = City;
