"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Button_1 = __importDefault(require("../Button"));
const Icons_1 = __importDefault(require("../Icons"));
const style_1 = __importDefault(require("./style"));
const Select_1 = __importDefault(require("../Select"));
const Input = ({ style = {}, value, placeholder = '请输入', type, template = true, maxLen = 0, onChange, }) => {
    const sexOptions = [
        { label: '男', value: 'man' },
        { label: '女', value: 'women' },
    ];
    const [current, setCurrent] = (0, react_1.useState)('');
    (0, react_1.useEffect)(() => {
        if (type === 'sex') {
            setCurrent(value);
        }
    }, [type]);
    const _onChange = (res) => {
        if (maxLen && res.length > maxLen) {
            res = res.substring(0, maxLen);
        }
        if (type && type === 'phone') {
            if (res.length > 11) {
                res = res.substring(0, 11);
            }
            if (!/^1/.test(res)) {
                res = '';
            }
            else {
                res = res.replace(/[^0-9]/ig, '');
            }
        }
        onChange === null || onChange === void 0 ? void 0 : onChange(res);
    };
    const _onSex = () => {
        (0, Select_1.default)({
            options: sexOptions,
            onSubmit: (item) => {
                setCurrent(item);
                _onChange(item);
            }
        });
    };
    const renderSex = () => {
        return (react_1.default.createElement(Button_1.default, { styleContainer: [style_1.default.container, style_1.default.sex, style], onPress: () => {
                _onSex();
            } },
            current ? (react_1.default.createElement(react_native_1.Text, null, current)) : (react_1.default.createElement(react_native_1.Text, { style: style_1.default.placeholder }, placeholder)),
            react_1.default.createElement(Icons_1.default, { type: 'SimpleLineIcons', name: 'arrow-right', color: '#999', size: 12 })));
    };
    const renderView = () => {
        if (type === 'sex') {
            return renderSex();
        }
        const config = {
            value,
            onChangeText: _onChange,
            autoCapitalize: 'none',
            autoCorrect: false,
            clearButtonMode: 'while-editing',
            placeholder,
            placeholderTextColor: '#bbb',
        };
        switch (type) {
            case 'phone':
                config.textContentType = 'telephoneNumber';
                config.keyboardType = 'phone-pad';
                break;
            case 'password':
                config.secureTextEntry = true;
                break;
        }
        if (!template) {
            config.style = style;
            return (react_1.default.createElement(react_native_1.TextInput, Object.assign({}, config)));
        }
        config.style = style_1.default.input;
        return (react_1.default.createElement(react_native_1.View, { style: [style_1.default.container, style] },
            react_1.default.createElement(react_native_1.TextInput, Object.assign({}, config))));
    };
    return renderView();
};
exports.default = Input;
