"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_webview_1 = require("react-native-webview");
const react_native_1 = require("react-native");
const Header_1 = __importDefault(require("./Header"));
const style_1 = __importDefault(require("./style"));
const config_1 = __importDefault(require("../Fn/config"));
const reducer_1 = __importDefault(require("../Fn/reducer"));
const env_1 = __importDefault(require("../Fn/env"));
const storage_1 = require("../Fn/storage");
const qs_1 = __importDefault(require("qs"));
const react_native_device_info_1 = require("react-native-device-info");
;
const ComponentView = ({ route, }) => {
    var _a, _b, _c, _d, _e, _f, _g;
    const refWebview = (0, react_1.useRef)(null);
    const back = (0, react_1.useRef)(false);
    const path = ((_a = route === null || route === void 0 ? void 0 : route.params) === null || _a === void 0 ? void 0 : _a.url) ? decodeURIComponent((_b = route === null || route === void 0 ? void 0 : route.params) === null || _b === void 0 ? void 0 : _b.url) : '';
    const title = ((_c = route === null || route === void 0 ? void 0 : route.params) === null || _c === void 0 ? void 0 : _c.title) ? decodeURIComponent((_d = route === null || route === void 0 ? void 0 : route.params) === null || _d === void 0 ? void 0 : _d.title) : config_1.default.pageTitle;
    const header = ((_e = route === null || route === void 0 ? void 0 : route.params) === null || _e === void 0 ? void 0 : _e.header) === false ? false : true;
    const params = ((_f = route === null || route === void 0 ? void 0 : route.params) === null || _f === void 0 ? void 0 : _f.params) ? (_g = route === null || route === void 0 ? void 0 : route.params) === null || _g === void 0 ? void 0 : _g.params : '';
    if (!path)
        return null;
    const initState = {
        viewConfigs: {},
        isLoaded: false,
    };
    const [state, dispatch] = (0, reducer_1.default)(Object.assign({}, initState));
    (0, react_1.useEffect)(() => {
        initPage();
    }, []);
    const initPage = () => __awaiter(void 0, void 0, void 0, function* () {
        const deviceId = yield (0, react_native_device_info_1.getUniqueId)();
        const $token = yield (0, storage_1.$getStorage)('$$token');
        const token = ($token === null || $token === void 0 ? void 0 : $token.accessToken) || '';
        const __token = JSON.stringify(JSON.stringify({
            value: {
                deviceId,
                token
            }
        }));
        const userAgent = `iduty_${config_1.default.userAgent} env_${config_1.default.env}`;
        const opts = {
            userAgent: env_1.default.isAndroid ? `android ${userAgent}` : `iphone ${userAgent}`
        };
        if (/^http/.test(path)) {
            opts.source = {
                uri: path
            };
        }
        else {
            if (env_1.default.isAndroid) {
                let url = `file:///android_asset/html/index.html#/${path}`;
                if (params)
                    url += `?${qs_1.default.stringify(params)}`;
                opts.injectedJavaScript = `window.localStorage.setItem('$$token', ${__token});`;
                opts.source = {
                    uri: url
                };
            }
            else {
                const __params = params ? `?${qs_1.default.stringify(params)}` : '';
                opts.injectedJavaScript = `window.localStorage.setItem('$$token', ${__token});
                    var path = window.location.href;
                    var url = path.replace('/loader.html', '/site/index.html#/${path}${__params}');
                    window.location.replace(url);`;
                opts.source = {
                    uri: 'Static.bundle/loader.html',
                    baseUrl: 'Static.bundle'
                };
            }
        }
        dispatch({
            viewConfigs: opts,
            isLoaded: true
        });
    });
    const onMessage = () => {
    };
    const viewConfigs = {
        style: style_1.default.webview,
        ref: refWebview,
        bounces: false,
        useWebKit: true,
        onMessage,
        originWhitelist: ['*'],
        allowFileAccess: true,
        javaScriptEnabled: true,
        allowingReadAccessToURL: '*',
        geolocationEnabled: false,
        allowsInlineMediaPlayback: true,
        allowUniversalAccessFromFileURLs: true,
        mediaPlaybackRequiresUserAction: false,
        allowFileAccessFromFileURLs: true,
        domStorageEnabled: true,
        onNavigationStateChange: (e) => {
            back.current = e.canGoBack;
        },
        onLoad: () => {
        },
        allowsFullscreenVideo: true,
        mixedContentMode: 'compatibility',
    };
    const renderView = () => {
        if (!(state === null || state === void 0 ? void 0 : state.isLoaded))
            return null;
        const configs = Object.assign(Object.assign({}, viewConfigs), state.viewConfigs);
        if (header) {
            return (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(react_native_1.SafeAreaView, { style: style_1.default.container },
                    react_1.default.createElement(Header_1.default, { title: title, refWebview: refWebview, back: back, header: true })),
                react_1.default.createElement(react_native_webview_1.WebView, Object.assign({}, configs))));
        }
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(react_native_1.SafeAreaView, { style: style_1.default.containerPosition },
                react_1.default.createElement(Header_1.default, { refWebview: refWebview, back: back, header: false })),
            react_1.default.createElement(react_native_webview_1.WebView, Object.assign({}, configs))));
    };
    return renderView();
};
exports.default = ComponentView;
